bash: print stderr в красном цвете

Есть ли способ сделать сообщения bash stderr красным цветом?

91 голос | спросил kolypto 27 AM00000010000004331 2009, 01:10:43

10 ответов


81
command 2> >(while read line; do echo -e "\e[01;31m$line\e[0m" >&2; done)
ответил Balázs Pozsár 27 AM00000010000003731 2009, 01:39:37
68

Способ 1: Использовать замену процесса:

command 2> >(sed $'s,.*,\e[31m&\e[m,'>&2)

Способ 2. Создайте функцию в сценарии bash:

color()(set -o pipefail;"[email protected]" 2>&1>&3|sed $'s,.*,\e[31m&\e[m,'>&2)3>&1

Используйте его следующим образом:

$ color command

Оба метода покажут команду stderr в красном цвете.

Продолжайте читать для объяснения того, как работает метод 2. Есть некоторые интересные функции, продемонстрированные этой командой.

  • color()... - Создает функцию bash, называемую цветом.
  • set -o pipefail â € "Это опция оболочки, которая сохраняет код возврата ошибки команды, выход которой передается в другую команду. Это делается в подоболочке, которая создается скобками, чтобы не изменять параметр pipefail во внешней оболочке.
  • "[email protected]" - Выполняет аргументы функции как новую команду. "[email protected]" эквивалентен "$1" "$2" ...
  • 2>&1 - перенаправляет команду stderr команды на stdout, чтобы она стала sed s stdin.
  • >&3 - сокращенное обозначение 1>&3, это перенаправляет stdout в новый дескриптор временного файла 3. 3 снова отправляется обратно в stdout.
  • sed ... - Из-за переадресаций выше, sed stdin - это stderr выполненная команда. Его функция состоит в том, чтобы окружать каждую строку цветовыми кодами.
  • $'...' Конструкция bash, которая заставляет ее понимать символы с экранированным обратным слэшем
  • .* - Совпадает со всей строкой.
  • \e[31m - escape-последовательность ANSI, которая вызывает следующие символы:
  • & - символ замены sed, который расширяется до всей согласованной строки (вся строка в этом случае).
  • \e[m - escape-последовательность ANSI, которая сбрасывает цвет.
  • >&2 - сокращенное обозначение 1>&2, это перенаправляет sed 'stdout на stderr.
  • 3>&1 - перенаправляет временный дескриптор файла 3 обратно в stdout.
ответил killdash9 24 AMpWed, 24 Apr 2013 00:53:12 +040053Wednesday 2013, 00:53:12
22

Вы также можете проверить stderred: https://github.com/sickill/stderred

ответил sickill 14 WedEurope/Moscow2011-12-14T01:40:19+04:00Europe/Moscow12bEurope/MoscowWed, 14 Dec 2011 01:40:19 +0400 2011, 01:40:19
13
ответил quaie 27 AM00000010000005931 2009, 01:18:59
10

Способ bash для создания stderr постоянно красного цвета использует 'exec' для перенаправления потоков. Добавьте в свой bashrc следующее:

exec 9>&2
exec 8> >(
    while IFS='' read -r line || [ -n "$line" ]; do
       echo -e "\033[31m${line}\033[0m"
    done
)
function undirect(){ exec 2>&9; }
function redirect(){ exec 2>&8; }
trap "redirect;" DEBUG
PROMPT_COMMAND='undirect;'

Я уже писал об этом ранее: Как установить цвет шрифта для STDOUT и STDERR

ответил gospes 29 Jpm1000000pmWed, 29 Jan 2014 12:49:12 +040014 2014, 12:49:12
6

Я создал сценарий оболочки, который реализует ответ Баласа Поццара в чистом баше. Сохраните его в командах $ PATH и prefix, чтобы раскрасить их вывод.

    #! /Bin /Баш

    если [$ 1 == "--help"]; тогда
        echo «Выполняет команду и раскрашивает все ошибки»
        echo "Пример:` basename $ {0} `wget ..."
        echo "(c) o_O Tync, ICQ # 1227-700, Enjoy!"
        выход 0
        фи

    # Temp-файл, чтобы поймать все ошибки
    TMP_ERRS = $ (Mktemp)

    # Выполнение команды
    "$ @" 2>> (при чтении строки, do echo -e "\ e [01; 31m $ line \ e [0m" | tee --append $ TMP_ERRS; сделано)
    EXIT_CODE = $?

    # Показать все ошибки снова.
    если [-s "$ TMP_ERRS"]; тогда
        echo -e "\ n \ n \ n \ e [01; 31m === ОШИБКИ === \ e [0m"
        cat $ TMP_ERRS
        фи
    rm -f $ TMP_ERRS

    # Конец
    exit $ EXIT_CODE

ответил kolypto 27 AM00000020000002931 2009, 02:13:29
2

Вы можете использовать такую ​​функцию


 #!/bin/sh

color() {
      printf '\033[%sm%s\033[m\n' "[email protected]"
      # usage color "31;5" "string"
      # 0 default
      # 5 blink, 1 strong, 4 underlined
      # fg: 31 red,  32 green, 33 yellow, 34 blue, 35 purple, 36 cyan, 37 white
      # bg: 40 black, 41 red, 44 blue, 45 purple
      }
string="Hello world!"
color '31;1' "$string" >&2

Я добавляю> & 2 для печати в stderr

ответил Ali Mezgani 27 AM00000020000005831 2009, 02:29:58
1

У меня есть слегка измененная версия скрипта O_o Tync. Мне нужно было сделать эти моды для OS X Lion, и это не идеально, потому что сценарий иногда завершается до того, как завершена команда. Я добавил сон, но я уверен, что есть лучший способ.

#!/bin/bash

   if [ $1 == "--help" ] ; then
       echo "Executes a command and colorizes all errors occured"
       echo "Example: `basename ${0}` wget ..."
       echo "(c) o_O Tync, ICQ# 1227-700, Enjoy!"
       exit 0
       fi

   # Temp file to catch all errors
   TMP_ERRS=`mktemp /tmp/temperr.XXXXXX` || exit 1

   # Execute command
   "[email protected]" 2> >(while read line; do echo -e "$(tput setaf 1)$line\n" | tee -a $TMP_ERRS; done)
   EXIT_CODE=$?

   sleep 1
   # Display all errors again
   if [ -s "$TMP_ERRS" ] ; then
       echo -e "\n\n\n$(tput setaf 1) === ERRORS === "
       cat $TMP_ERRS
   else
       echo "No errors collected in $TMP_ERRS"
   fi
   rm -f $TMP_ERRS

   # Finish
   exit $EXIT_CODE
ответил Cliff 8 J0000006Europe/Moscow 2012, 21:37:56
1

Это решение сработало для меня: https://superuser.com /вопросы /28869 /сразу-сказать-какой-выход-был посланный к STDERR

Я поместил эту функцию в свой .bashrc или .zshrc:

# Red STDERR
# rse <command string>
function rse()
{
    # We need to wrap each phrase of the command in quotes to preserve arguments that contain whitespace
    # Execute the command, swap STDOUT and STDERR, colour STDOUT, swap back
    ((eval $(for phrase in "[email protected]"; do echo -n "'$phrase' "; done)) 3>&1 1>&2 2>&3 | sed -e "s/^\(.*\)$/$(echo -en \\033)[31;1m\1$(echo -en \\033)[0m/") 3>&1 1>&2 2>&3
}

Тогда, например:

$ rse cat non_existing_file.txt

даст мне красный вывод.

ответил Eyal Levin 25 PM000000120000001731 2016, 12:16:17
0

версию, используя fifos

mkfifo errs
stdbuf -o0 -e0 -i0 grep . foo | while read line; do echo -e "\e[01;31m$line  \e[0m" >&2; done &
stdbuf -o0 -e0 -i0 sh $script 2>errs
ответил untore 4 J0000006Europe/Moscow 2017, 13:04:05

Похожие вопросы

Популярные теги

security × 330linux × 316macos × 2827 × 268performance × 244command-line × 241sql-server × 235joomla-3.x × 222java × 189c++ × 186windows × 180cisco × 168bash × 158c# × 142gmail × 139arduino-uno × 139javascript × 134ssh × 133seo × 132mysql × 132